/*
  Tutanchamun, an arcade game
  Copyright (C) 1998  David Kastrup
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  */
#include "tutan.h"

const ubyte stage1[][12],
  stage2[][12],
  stage3[][12],
  stage4[][12];

staget stages[16] = {
  {31,
   12,0,
   12,4,0,0,
   -4,
   4,2,				/* colours */
   {{0,0},{0,0}},		/* addkey */
   {{0,0},{0,0}},		/* addhol */
   " 90",			/* time */
   {&snamph, &spimph, &batmph},
   stage1,
   {{{44,16},255,56,
     0x5599bfff},
    {{68,8},255,44,
     0xaaafbbbf},
    {{108,20},255,172,
     0xffffffff}}},
  {63,
   4,36,
   20,16,4,28,
   -4,
   5,2,
   {{0,0},{0,0}},
   {{0,0},{0,0}},
   "130",
   {&snamph, &spimph, &batmph},
   stage2,
   {{{40,16},255,124,
     0x5569aaea},
    {{68,20},255,208,
     0x555d777f},
    {{88,24},255,136,
     0xaaaaaaaa},
    {{112,24},255,84,
     0xffffffff},
    {{140,36},255,176,
     0xaaaebbbb},
    {{172,12},255,112,
     0xaaaebbbb}}},
  {63,
   4,36,
   4,40,32,12,
   -4,
   1,2,
   {{0,0},{0,0}},
   {{0,0},{0,0}},
   "180",
   {&snamph, &skumph, &batmph},
   stage3,
   {{{44,20},255,136,
     0x5566aaba},
    {{80,8},255,72,
     0x5566aaba},
    {{100,24},255,156,
     0x5566aaba},
    {{140,24},255,116,
     0xaaaebbbb},
    {{172,24},255,28,
     0xaaaebbbb},
    {{208,8},255,68,
     0xaebabbbf},
    {{236,8},255,240,
     0xfffbffff}}},
  {63,
   4,36,
   20,20,24,4,
   -4,
   0,2,
   {{0,0},{0,0}},
   {{0,0},{0,0}},
   "210",
   {&snamph, &skumph, &whemph},
   stage4,
   {{{44,24},255,148,
     0x556aaebb},
    {{80,28},255,132,
     0x596aabbb},
    {{116,16},255,16,
     0x666ebbbb},
    {{156,8},255,136,
     0xaaaaaaaa},
    {{180,4},255,216,
     0xccf3ffff},
    {{228,24},255,84,
     0xaebbbeee}}},
  {31,
   12,0,
   12,4,0,0,
   -3,
   4,6,
   {{72,36},{0,0}},
   {{100,36},{0,0}},
   "120",
   {&snamph, &spimph, &batmph},
   stage1,
   {{{44,16},255,56,
     0x5599bfff},
    {{68,8},255,44,
     0xaaafbbbf},
    {{108,20},255,172,
     0xffffffff}}},
  {63,
   4,36,
   20,16,4,28,
   -3,
   5,6,
   {{36,40},{0,0}},
   {{148,4},{0,0}},
   "160",
   {&snamph, &spimph, &batmph},
   stage2,
   {{{40,16},255,124,
     0x5569aaea},
    {{68,20},255,208,
     0x555d777f},
    {{88,24},255,136,
     0xaaaaaaaa},
    {{112,24},255,84,
     0xffffffff},
    {{140,36},255,176,
     0xaaaebbbb},
    {{172,12},255,112,
     0xaaaebbbb},
    {{216,32},255,24,
     0xaaaebbbb}}},
  {63,
   4,36,
   4,40,32,12,
   -3,
   1,6,
   {{164,4},{0,0}},
   {{224,36},{0,0}},
   "230",
   {&snamph, &skumph, &batmph},
   stage3,
   {{{44,20},255,136,
     0x5566aaba},
    {{80,8},255,72,
     0x5566aaba},
    {{100,24},255,156,
     0x5566aaba},
    {{140,24},255,116,
      0xaaaebbbb},
    {{172,24},255,28,
     0xaaaebbbb},
    {{208,8},255,68,
     0xaebabbbf},
    {{236,8},255,240,
     0xfffbffff}}},
  {63,
   4,36,
   20,20,24,4,
   -3,
   0,6,
   {{128,40},{0,0}},
   {{224,36},{0,0}},
   "290",
   {&snamph, &skumph, &whemph},
   stage4,
   {{{44,24},255,148,
     0x556aaebb},
    {{80,28},255,132,
     0x596aabbb},
    {{116,16},255,16,
     0x666ebbbb},
    {{156,8},255,136,
     0xaaaaaaaa},
    {{180,4},255,216,
     0xccf3ffff},
    {{228,24},255,84,
     0xaebbbeee}}},
  {31,
   12,0,
   12,4,0,0,
   -4,
   4,1,
   {{72,36},{0,0}},
   {{100,36},{0,0}},
   "120",
   {&eggmph, &spimph, &batmph},
   stage1,
   {{{44,16},255,56,
     0x5599bfff},
    {{68,8},255,44,
     0xaaafbbbf},
    {{108,20},255,172,
     0xffffffff}}},
  {63,
   4,36,
   20,16,4,28,
   -4,
   5,0,
   {{36,40},{0,0}},
   {{148,4},{0,0}},
   "160",
   {&eggmph, &spimph, &batmph},
   stage2,
   {{{40,16},255,124,
     0x5569aaea},
    {{68,20},255,208,
     0x555d777f},
    {{88,24},255,136,
     0xaaaaaaaa},
    {{112,24},255,84,
     0xffffffff},
    {{140,36},255,176,
     0xaaaebbbb},
    {{172,12},255,112,
     0xaaaebbbb},
    {{216,32},255,24,
     0xaaaebbbb}}},
  {63,
   4,36,
   4,40,32,12,
   -4,
   1,4,
   {{164,4},{0,0}},
   {{224,36},{0,0}},
   "230",
   {&eggmph, &skumph, &batmph},
   stage3,
   {{{44,20},255,136,
     0x5566aaba},
    {{80,8},255,72,
     0x5566aaba},
    {{100,24},255,156,
     0x5566aaba},
    {{140,24},255,116,
     0xaaaebbbb},
    {{172,24},255,28,
     0xaaaebbbb},
    {{208,8},255,68,
     0xaebabbbf},
    {{236,8},255,240,
     0xfffbffff}}},
  {63,
   4,36,
   20,20,24,4,
   -4,
   0,5,
   {{128,40},{168,4}},
   {{220,36},{224,36}},
   "340",
   {&eggmph, &skumph, &whemph},
   stage4,
   {{{44,24},255,148,
     0x556aaebb},
    {{80,28},255,132,
     0x596aabbb},
    {{116,16},255,16,
     0x666ebbbb},
    {{156,8},255,136,
     0xaaaaaaaa},
    {{180,4},255,216,
     0xccf3ffff},
    {{228,24},255,84,
     0xaebbbeee}}},
  {31,
   12,0,
   12,4,0,0,
   -3,
   4,7,
   {{72,36},{0,0}},
   {{100,36},{0,0}},
   "120",
   {&eggmph, &spimph, &batmph},
   stage1,
   {{{44,16},255,56,
     0x5599bfff},
    {{68,8},255,44,
     0xaaafbbbf},
    {{108,20},255,172,
     0xffffffff}}},
  {63,
   4,36,
   20,16,4,28,
   -3,
   5,7,
   {{36,40},{0,0}},
   {{148,4},{0,0}},
   "160",
   {&eggmph, &spimph, &batmph},
   stage2,
   {{{40,16},255,124,
     0x5569aaea},
    {{68,20},255,208,
     0x555d777f},
    {{88,24},255,136,
     0xaaaaaaaa},
    {{112,24},255,84,
     0xffffffff},
    {{140,36},255,176,
     0xaaaebbbb},
    {{172,12},255,112,
     0xaaaebbbb},
    {{216,32},255,24,
     0xaaaebbbb}}},
  {63,
   4,36,
   4,40,32,12,
   -3,
   1,7,
   {{164,4},{0,0}},
   {{224,36},{0,0}},
   "230",
   {&eggmph, &skumph, &batmph},
   stage3,
   {{{44,20},255,136,
     0x5566aaba},
    {{80,8},255,72,
     0x5566aaba},
    {{100,24},255,156,
     0x5566aaba},
    {{140,24},255,116,
     0xaaaebbbb},
    {{172,24},255,28,
     0xaaaebbbb},
    {{208,8},255,68,
     0xaebabbbf},
    {{236,8},255,240,
     0xfffbffff}}},
  {63,
   4,36,
   20,20,24,4,
   -3,
   0,7,
   {{128,40},{168,4}},
   {{220,36},{224,36}},
   "340",
   {&eggmph, &skumph, &whemph},
   stage4,
   {{{44,24},255,148,
     0x556aaebb},
    {{80,28},255,132,
     0x596aabbb},
    {{116,16},255,16,
     0x666ebbbb},
    {{156,8},255,136,
     0xaaaaaaaa},
    {{180,4},255,216,
     0xccf3ffff},
    {{228,24},255,84,
     0xaebbbeee}}}};

const ubyte stage1[][12] = {
  {XX,XX,XX,XX,XX,XX,XX,XX,XX,XX,XX,XX},
  {GA,GA,GA,GA,GA,GA,GA,GA,XX,XX,XX,XX},
  {GA,GA,GA,GA,GA,GA,GA,GA,XX,XX,XX,XX},
  {GA,GA,GA,GA,GA,GA,GA,GA,XX,XX,XX,XX},
  {XX,XX,XX,XX,XX,XX,XX,GA,XX,XX,XX,XX},
  {XX,GA,GA,GA,XX,GA,GA,GA,XX,XX,XX,XX},
  {XX,GA,XX,GA,XX,GA,XX,GA,XX,XX,XX,XX},
  {XX,GA,XX,GA,GA,GA,XX,GA,XX,OB,BO,XX},
  {XX,GA,XX,GA,XX,GA,GA,GA,XX,XX,GA,XX},
  {XX,GA,GA,GA,XX,GA,XX,XX,XX,XX,GA,XX},
  {XX,GA,XX,GA,GA,GA,XX,XX,GA,GA,GA,XX},
  {XX,GA,UL,EO,GA,EU,XX,GA,GA,OL,GA,XX},
  {XX,GA,AO,XX,ER,XX,XX,GA,XX,AU,GA,XX},
  {XX,GA,UR,XX,XX,XX,XX,GA,GA,OR,GA,XX},
  {XX,SR,XX,XX,XX,XX,XX,XX,GA,XX,GA,XX},
  {XX,SC,XX,XX,XX,GA,GA,GA,GA,GA,GA,XX},
  {XX,XX,EL,XX,XX,GA,XX,GA,XX,GA,XX,XX},
  {XX,EO,GA,GA,GA,GA,GA,GA,XX,GA,XX,XX},
  {XX,XX,ER,GA,XX,XX,GA,XX,XX,SX,XX,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,XX,XX,XX,XX},
  {XX,GA,XX,XX,XX,GA,XX,GA,XX,XX,XX,XX},
  {XX,GA,XX,XX,GA,GA,XX,BU,UB,XX,XX,XX},
  {XX,GA,GA,GA,GA,XX,XX,XX,XX,XX,XX,XX},
  {XX,GA,XX,XX,XX,XX,GA,GA,GA,GA,XX,XX},
  {XX,GA,XX,GA,GA,GA,GA,XX,XX,GA,XX,XX},
  {XX,GA,XX,GA,GA,XX,XX,XX,XX,LR,XX,XX},
  {XX,GA,GA,GA,GA,EL,XX,XX,XX,LO,XX,XX},
  {XX,GA,XX,GA,GA,GA,EU,XX,T1,T4,T7,XX},
  {XX,GA,XX,GA,XX,ER,XX,XX,T2,T5,T8,XX},
  {XX,GA,GA,GA,GA,GA,BU,UB,T3,T6,T9,XX},
  {XX,XX,XX,XX,XX,XX,XX,XX,XX,XX,XX,XX}
}, stage2[][12] = {
  {XX,XX,XX,XX,XX,XX,XX,XX,XX,GA,XX,XX},
  {XX,XX,XX,XX,XX,XX,XX,XX,XX,GA,XX,XX},
  {XX,XX,XX,XX,XX,XX,XX,XX,XX,GA,XX,XX},
  {XX,XX,XX,XX,XX,XX,XX,XX,XX,GA,XX,XX},
  {XX,XX,XX,XX,XX,GA,GA,GA,GA,GA,GA,XX},
  {XX,XX,XX,XX,XX,GA,XX,XX,XX,XX,GA,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,XX,GA,XX},
  {XX,GA,XX,XX,XX,GA,XX,XX,GA,GA,GA,XX},
  {XX,GA,XX,XX,GA,GA,GA,XX,GA,XX,GA,XX},
  {XX,GA,GA,GA,GA,XX,GA,GA,GA,XX,SX,XX},
  {XX,OL,GA,EO,GA,EU,GA,XX,GA,UL,XX,XX},
  {XX,AO,GA,XX,ER,XX,GA,XX,GA,AU,XX,XX},
  {XX,OR,GA,GA,GA,XX,BU,UB,GA,UR,XX,XX},
  {XX,GA,GA,XX,GA,XX,XX,XX,GA,GA,GA,XX},
  {XX,GA,XX,XX,GA,XX,XX,XX,GA,XX,GA,XX},
  {XX,GA,GA,GA,GA,XX,GA,GA,GA,XX,GA,XX},
  {XX,GA,XX,GA,XX,EL,XX,GA,XX,XX,GA,XX},
  {XX,GA,OB,BO,EO,GA,GA,GA,GA,XX,GA,XX},
  {XX,SR,XX,XX,XX,ER,GA,GA,GA,XX,GA,XX},
  {XX,SC,XX,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,XX,XX,GA,XX,GA,XX,GA,GA,XX,XX,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,GA,UL,XX,GA,EO,GA,EU,XX,OL,GA,XX},
  {XX,GA,AO,XX,GA,XX,ER,XX,XX,AU,GA,XX},
  {XX,GA,UR,XX,GA,XX,XX,GA,XX,OR,GA,XX},
  {XX,GA,GA,GA,GA,XX,XX,GA,GA,GA,GA,XX},
  {XX,GA,XX,XX,GA,GA,BU,UB,GA,XX,XX,XX},
  {XX,GA,GA,GA,GA,XX,EL,XX,GA,GA,GA,XX},
  {XX,XX,XX,GA,XX,EO,GA,EU,XX,XX,SR,XX},
  {XX,XX,GA,GA,GA,GA,GA,GA,GA,XX,SC,XX},
  {XX,OL,GA,XX,XX,XX,GA,XX,GA,XX,UL,XX},
  {XX,AO,GA,GA,GA,GA,GA,XX,GA,GA,AU,XX},
  {XX,OR,GA,XX,GA,XX,XX,XX,XX,GA,UR,XX},
  {XX,XX,BU,UB,GA,GA,GA,XX,GA,GA,XX,XX},
  {XX,XX,XX,XX,XX,XX,GA,XX,GA,EL,XX,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,EU,XX},
  {XX,GA,XX,XX,GA,XX,XX,XX,XX,ER,XX,XX},
  {XX,LR,XX,XX,XX,XX,XX,XX,XX,XX,XX,XX},
  {XX,LO,XX,XX,XX,XX,XX,XX,XX,XX,XX,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,GA,GA,GA,GA,BU,UB,GA,GA,GA,GA,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,GA,GA,OB,BO,GA,GA,GA,GA,GA,GA,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,GA,GA,GA,GA,GA,GA,XX,XX,LR,XX,XX},
  {XX,GA,GA,GA,GA,GA,GA,XX,XX,LO,XX,XX},
  {XX,XX,XX,XX,XX,XX,XX,XX,T1,T4,T7,XX},
  {XX,XX,XX,XX,XX,XX,XX,XX,T2,T5,T8,XX},
  {XX,XX,XX,XX,XX,XX,XX,XX,T3,T6,T9,XX},
  {XX,XX,XX,XX,XX,XX,XX,XX,XX,XX,XX,XX}
}, stage3[][12] = {
  {XX,XX,XX,XX,XX,XX,XX,XX,XX,GA,XX,XX},
  {XX,XX,XX,XX,XX,XX,XX,XX,XX,GA,XX,XX},
  {XX,XX,XX,XX,XX,XX,XX,XX,XX,GA,XX,XX},
  {XX,XX,XX,XX,XX,XX,XX,XX,XX,GA,XX,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,GA,XX,XX,XX,XX,XX,XX,XX,XX,XX,XX},
  {XX,GA,XX,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,GA,UL,XX,GA,XX,XX,GA,XX,OL,GA,XX},
  {XX,GA,AO,XX,GA,GA,GA,GA,XX,AU,GA,XX},
  {XX,GA,UR,XX,GA,XX,XX,GA,XX,OR,GA,XX},
  {XX,GA,XX,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,GA,XX,SR,EO,GA,EU,XX,GA,XX,GA,XX},
  {XX,GA,XX,SC,XX,ER,XX,XX,BU,UB,GA,XX},
  {XX,GA,XX,XX,XX,XX,XX,XX,XX,XX,GA,XX},
  {XX,GA,XX,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,GA,XX,GA,XX,XX,XX,XX,XX,XX,XX,XX},
  {XX,GA,GA,GA,XX,XX,GA,GA,GA,GA,GA,XX},
  {XX,GA,GA,GA,GA,GA,GA,XX,SR,XX,GA,XX},
  {XX,GA,GA,GA,GA,GA,GA,XX,SC,XX,GA,XX},
  {XX,XX,EL,XX,XX,GA,GA,GA,XX,GA,GA,XX},
  {XX,EO,GA,EU,GA,XX,GA,GA,GA,GA,GA,XX},
  {XX,GA,GA,GA,GA,XX,XX,XX,XX,XX,GA,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,GA,GA,GA,GA,GA,XX,GA,GA,GA,GA,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,GA,GA,XX,XX,EO,GA,EU,XX,XX,XX,XX},
  {XX,GA,GA,GA,GA,XX,ER,XX,GA,GA,GA,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,GA,GA,GA,XX,GA,XX,GA,XX,GA,XX,XX},
  {XX,GA,GA,GA,XX,XX,XX,XX,XX,BU,UB,XX},
  {XX,GA,GA,GA,XX,XX,XX,XX,XX,XX,XX,XX},
  {XX,GA,GA,XX,GA,XX,GA,XX,GA,BU,UB,XX},
  {XX,GA,GA,XX,GA,GA,GA,XX,GA,XX,XX,XX},
  {XX,GA,XX,GA,GA,XX,GA,GA,GA,GA,XX,XX},
  {XX,GA,XX,GA,XX,XX,EL,GA,XX,GA,XX,XX},
  {XX,GA,GA,GA,GA,EO,GA,GA,GA,GA,GA,XX},
  {XX,GA,XX,XX,GA,XX,ER,GA,XX,XX,GA,XX},
  {XX,XX,OB,BO,GA,GA,GA,GA,GA,XX,GA,XX},
  {XX,XX,XX,XX,XX,GA,XX,XX,GA,XX,GA,XX},
  {XX,GA,GA,GA,XX,GA,GA,GA,GA,XX,GA,XX},
  {XX,GA,XX,GA,XX,XX,XX,XX,XX,XX,GA,XX},
  {XX,SX,XX,GA,GA,GA,XX,GA,GA,GA,GA,XX},
  {XX,XX,GA,GA,GA,GA,GA,GA,GA,XX,GA,XX},
  {XX,XX,GA,GA,GA,EO,GA,EU,GA,XX,XX,XX},
  {XX,XX,GA,GA,GA,XX,ER,XX,GA,XX,XX,XX},
  {XX,XX,GA,GA,GA,GA,GA,GA,GA,XX,XX,XX},
  {XX,XX,XX,XX,GA,GA,GA,GA,GA,BU,UB,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,XX,XX,XX,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX,XX},
  {XX,GA,GA,XX,XX,XX,GA,XX,XX,GA,XX,XX},
  {XX,XX,GA,GA,GA,GA,GA,GA,GA,GA,XX,XX},
  {XX,XX,EL,GA,GA,XX,XX,XX,XX,XX,XX,XX},
  {XX,EO,GA,GA,XX,XX,XX,XX,XX,XX,XX,XX},
  {XX,XX,ER,GA,GA,XX,GA,GA,GA,GA,XX,XX},
  {XX,XX,XX,GA,GA,GA,GA,XX,XX,GA,XX,XX},
  {XX,GA,GA,GA,GA,GA,GA,XX,XX,GA,XX,XX},
  {XX,GA,XX,XX,XX,GA,GA,XX,XX,LR,XX,XX},
  {XX,GA,XX,GA,GA,GA,GA,XX,XX,LO,XX,XX},
  {XX,GA,GA,GA,XX,XX,GA,XX,XX,LO,XX,XX},
  {XX,EO,GA,EU,XX,OB,BO,XX,T1,T4,T7,XX},
  {XX,XX,ER,XX,XX,XX,XX,XX,T2,T5,T8,XX},
  {XX,XX,XX,XX,XX,XX,XX,XX,T3,T6,T9,XX},
  {XX,XX,XX,XX,XX,XX,XX,XX,XX,XX,XX,XX}
}, stage4[][12] = {
  {XX,XX,XX,XX,XX,XX,XX,XX,XX,GA,XX,XX},
  {XX,XX,XX,XX,XX,XX,XX,XX,XX,GA,XX,XX},
  {XX,XX,XX,XX,XX,XX,XX,XX,XX,GA,XX,XX},
  {XX,XX,XX,XX,XX,XX,XX,XX,XX,GA,XX,XX},
  {XX,GA,GA,SR,GA,GA,XX,GA,GA,GA,XX,XX},
  {XX,GA,XX,SC,XX,GA,XX,GA,XX,GA,XX,XX},
  {XX,GA,GA,XX,XX,GA,XX,GA,XX,GA,XX,XX},
  {XX,OL,GA,GA,GA,GA,GA,GA,GA,GA,UL,XX},
  {XX,AO,GA,XX,XX,XX,GA,XX,XX,GA,AU,XX},
  {XX,OR,GA,XX,BU,UB,GA,XX,GA,GA,UR,XX},
  {XX,XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,XX,XX,XX,GA,EO,GA,EU,XX,XX,GA,XX},
  {XX,XX,XX,XX,GA,XX,ER,XX,XX,XX,GA,XX},
  {XX,XX,GA,GA,GA,XX,XX,XX,GA,GA,GA,XX},
  {XX,XX,OL,GA,XX,XX,XX,XX,GA,XX,UL,XX},
  {XX,XX,AO,GA,XX,GA,GA,GA,GA,GA,AU,XX},
  {XX,XX,OR,GA,XX,GA,XX,XX,XX,GA,UR,XX},
  {XX,GA,GA,GA,XX,GA,XX,GA,GA,GA,GA,XX},
  {XX,SR,XX,XX,XX,GA,GA,GA,XX,XX,GA,XX},
  {XX,SC,XX,GA,GA,GA,XX,EL,XX,OB,BO,XX},
  {XX,XX,XX,GA,XX,GA,EO,GA,EU,XX,XX,XX},
  {XX,GA,GA,GA,XX,GA,GA,GA,GA,GA,XX,XX},
  {XX,GA,XX,XX,XX,XX,XX,GA,XX,GA,XX,XX},
  {XX,GA,GA,GA,XX,GA,GA,GA,XX,GA,GA,XX},
  {XX,XX,XX,GA,XX,GA,XX,XX,XX,XX,GA,XX},
  {XX,OB,BO,GA,GA,GA,GA,GA,XX,GA,GA,XX},
  {XX,XX,XX,XX,XX,XX,XX,GA,XX,GA,XX,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,GA,UL,XX,EL,XX,GA,OL,XX,XX,GA,XX},
  {XX,GA,AO,EO,GA,EU,XX,AU,GA,GA,GA,XX},
  {XX,GA,UR,XX,GA,XX,XX,OR,GA,GA,GA,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,XX,GA,XX},
  {XX,XX,GA,XX,XX,XX,GA,XX,XX,XX,SX,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,GA,XX,XX,GA,XX,XX,XX,XX,XX,GA,XX},
  {XX,GA,XX,XX,GA,GA,GA,GA,GA,XX,GA,XX},
  {XX,GA,XX,XX,XX,XX,XX,XX,GA,XX,GA,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,XX,EL,XX,XX,XX,GA,XX,XX,XX,GA,XX},
  {XX,EO,GA,EU,XX,XX,XX,XX,XX,GA,GA,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,GA,XX,GA,GA,GA,GA,XX,GA,GA,GA,XX},
  {XX,SX,XX,GA,GA,GA,GA,XX,GA,GA,GA,XX},
  {XX,XX,XX,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {XX,EL,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX},
  {EO,GA,GA,XX,XX,EO,GA,EU,XX,XX,BU,UB},
  {XX,ER,GA,XX,XX,XX,ER,XX,GA,XX,XX,XX},
  {XX,XX,GA,GA,GA,GA,GA,GA,GA,GA,BU,UB},
  {XX,XX,XX,XX,XX,GA,XX,XX,XX,GA,XX,XX},
  {XX,GA,GA,GA,GA,GA,GA,GA,GA,GA,XX,XX},
  {XX,GA,XX,XX,XX,XX,GA,XX,XX,XX,XX,XX},
  {XX,GA,GA,GA,GA,XX,XX,XX,XX,XX,XX,XX},
  {XX,XX,XX,XX,GA,XX,XX,GA,GA,GA,XX,XX},
  {XX,GA,GA,GA,GA,XX,XX,GA,XX,GA,XX,XX},
  {XX,GA,XX,XX,XX,XX,XX,GA,XX,GA,XX,XX},
  {XX,GA,XX,XX,XX,GA,GA,GA,XX,GA,XX,XX},
  {XX,GA,XX,XX,XX,GA,EL,XX,XX,LR,XX,XX},
  {XX,GA,GA,GA,GA,GA,GA,EU,XX,LO,XX,XX},
  {XX,GA,XX,GA,GA,XX,ER,XX,XX,LO,XX,XX},
  {XX,GA,XX,GA,GA,GA,XX,XX,T1,T4,T7,XX},
  {XX,GA,GA,GA,GA,GA,BU,UB,T2,T5,T8,XX},
  {XX,XX,XX,XX,XX,XX,XX,XX,T3,T6,T9,XX},
  {XX,XX,XX,XX,XX,XX,XX,XX,XX,XX,XX,XX}
};
